package App::Clifton::Service;

use aliased 'App::Clifton::Task';
use Moo;

extends 'App::Clifton::Component';

sub _do {
  my ($self, $do, @args) = @_;
  my $body = do {
    my $body_call = $self->_capture_weakself("_body_for_${do}");
    sub { $body_call->(@args, @_) }
  };
  my $deps = {};
  if (my $dep_call = $self->can("_dependencies_for_${do}")) {
    $deps = $self->$dep_call(@args);
  }
  $self->_new_child(Task, {
    name => $do, body => $body, dependencies => $deps
  });
}

1;
